''*************************************
''*  Altair Simulator Memory v2.0     *
''*  (C) 2008 Michael Rychlik         *
''*************************************

' v1.0 - 01 Oct 2007 - original version
' v1.1 - 09 Dec 2007 - No change just bump verion inline with other modules
' v1.2 - 09 Mar 2008 - No change, just bump version 
' v1.3 - 20 Mar 2008 - Added Altair ROM area loaded from file BOOTDSK.COM
'                      ROM is accessed by CBIOSX to get the boot up disk number
'                      otherwise is not usd as we have all of CP/M loaded already
'                    - Added the instructions set test program (T8080.com)
'                      to the Transien Program Area (TPA). 
' v1.4 - 21 Mar 2008 - Bumped version.
' v2.0 - 22 Mar 2008 - Removed loading of CCP, BDOS and CBIOSX into DAT section.
'                    - Moved ram_8080 to VAR section.
'                    - With this change the CPU runs through RAM from 0000 at boot, executing NOPS 00
'                      until it hits the DSKBOOT bootloader ROM. So bingo! it boots from SD card.
'                    - The test T8080.COM is no longer loaded or run on start up. It is no longer
'                      required to even pad out RAM upto the CCP.
                                      
CON
  'WARNING !!! Change msize in altair_ios also if you change it here !!!
  msize =  24          ' Adjust per installed system memory (K bytes)


VAR
  'The RAM used by the CPU emulator
  byte ram_8080[msize * 1024]

PUB init : Success
{
}

PUB get_ram_base : ram_base
  ram_base := @ram_8080

PUB get_rom_base : rom_base
  rom_base := @rom_8080

PUB get_size : size
  size := msize * 1024



DAT
        'Load Altair boot rom. This file is the result of assembling DSKBOOT.MAC inside the SIMH Altair 8800 simulator.
        rom_8080        file "DSKBOOT.COM"